Index: plugins/tools/tool_crop/kis_tool_crop.cc
===================================================================
--- plugins/tools/tool_crop/kis_tool_crop.cc	(revision 1177751)
+++ plugins/tools/tool_crop/kis_tool_crop.cc	(working copy)
@@ -52,7 +52,6 @@
         : KisTool(canvas, KisCursor::load("tool_crop_cursor.png", 6, 6))
 {
     setObjectName("tool_crop");
-    m_selecting = false;
     m_rectCrop = QRect(0, 0, 0, 0);
     m_handleSize = 13;
     m_haveCropSelection = false;
@@ -88,7 +87,6 @@
 
 void KisToolCrop::deactivate()
 {
-    m_selecting = false;
     m_haveCropSelection = false;
     m_rectCrop = QRect(0, 0, 0, 0);
     updateWidgetValues();
@@ -117,191 +115,188 @@
     paintOutlineWithHandles(painter);
 }
 
-void KisToolCrop::mousePressEvent(KoPointerEvent *e)
+void KisToolCrop::mousePressEvent(KoPointerEvent *event)
 {
-    if (canvas()) {
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
 
-        if (!currentNode())
-            return;
+        setMode(KisTool::PAINT_MODE);
 
-        if (currentImage() && e->button() == Qt::LeftButton) {
+        QPoint pos = convertToIntPixelCoord(event);
 
-            QPoint pos = convertToIntPixelCoord(e);
+        pos.setX(qBound(0, pos.x(), image()->width() - 1));
+        pos.setY(qBound(0, pos.y(), image()->height() - 1));
 
-            pos.setX(qBound(0, pos.x(), image()->width() - 1));
-            pos.setY(qBound(0, pos.y(), image()->height() - 1));
-
-            m_selecting = true;
-
-            if (!m_haveCropSelection) { //if the selection is not set
-                m_rectCrop = QRect(pos.x(), pos.y(), 1, 1);
-                updateCanvasPixelRect(image()->bounds());
-            } else {
-                m_mouseOnHandleType = mouseOnHandle(pixelToView(convertToPixelCoord(e)));
-                m_dragStart = pos;
-            }
+        if (!m_haveCropSelection) { //if the selection is not set
+            m_rectCrop = QRect(pos.x(), pos.y(), 1, 1);
+            updateCanvasPixelRect(image()->bounds());
+        } else {
+            m_mouseOnHandleType = mouseOnHandle(pixelToView(convertToPixelCoord(event)));
+            m_dragStart = pos;
         }
+
     }
+    else {
+        KisTool::mousePressEvent(event);
+    }
 }
 
-#include <QDebug>
-
-void KisToolCrop::mouseMoveEvent(KoPointerEvent *e)
+void KisToolCrop::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (canvas() && currentImage()) {
-        if (m_selecting) { //if the user selects
-            QPoint pos = convertToIntPixelCoord(e);
+    QPointF pos = convertToPixelCoord(event);
 
-            if (!m_haveCropSelection) { //if the cropSelection is not yet set
-                QRectF updateRect = boundingRect();
+    if (m_haveCropSelection) {  //if the crop selection is set
+        qint32 type = mouseOnHandle(pixelToView(pos));
+        //set resize cursor if we are on one of the handles
+        setMoveResizeCursor(type);
+    }
 
-                m_rectCrop.setBottomRight(convertToIntPixelCoord(e));
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
 
-                m_rectCrop.setRight(qBound(0, m_rectCrop.right(), image()->width() - 1));
-                m_rectCrop.setBottom(qBound(0, m_rectCrop.bottom(), image()->height() - 1));
+        if (!m_haveCropSelection) { //if the cropSelection is not yet set
+            QRectF updateRect = boundingRect();
+            m_rectCrop.setBottomRight(pos.toPoint());
 
-                updateRect |= boundingRect();
-                updateCanvasViewRect(updateRect);
+            m_rectCrop.setRight(qBound(0, m_rectCrop.right(), image()->width() - 1));
+            m_rectCrop.setBottom(qBound(0, m_rectCrop.bottom(), image()->height() - 1));
 
-                QRect r = m_rectCrop.normalized();
-                setOptionWidgetRatio((double)r.width() / (double)r.height());
+            updateRect |= boundingRect();
+            updateCanvasViewRect(updateRect);
 
-            } else { //if the crop selection is set
-                QPoint dragStop = pos;
-                QPoint drag = dragStop - m_dragStart;
+            QRect r = m_rectCrop.normalized();
+            setOptionWidgetRatio((double)r.width() / (double)r.height());
 
-                if (m_mouseOnHandleType != None && m_dragStart != dragStop) {
+        } else { //if the crop selection is set
+            QPoint dragStop = pos.toPoint();
+            QPoint drag = dragStop - m_dragStart;
 
-                    qint32 imageWidth = currentImage()->width();
-                    qint32 imageHeight = currentImage()->height();
+            if (m_mouseOnHandleType != None && m_dragStart != dragStop) {
 
-                    QRectF updateRect = boundingRect();
+                qint32 imageWidth = currentImage()->width();
+                qint32 imageHeight = currentImage()->height();
 
-                    if (m_mouseOnHandleType == Inside) {
-                        m_rectCrop.translate(drag);
+                QRectF updateRect = boundingRect();
 
-                        if (m_rectCrop.left() < 0) {
-                            m_rectCrop.moveLeft(0);
+                if (m_mouseOnHandleType == Inside) {
+                    m_rectCrop.translate(drag);
+
+                    if (m_rectCrop.left() < 0) {
+                        m_rectCrop.moveLeft(0);
+                    }
+                    if (m_rectCrop.right() > imageWidth - 1) {
+                        m_rectCrop.moveRight(imageWidth - 1);
+                    }
+                    if (m_rectCrop.top() < 0) {
+                        m_rectCrop.moveTop(0);
+                    }
+                    if (m_rectCrop.bottom() > imageHeight - 1) {
+                        m_rectCrop.moveBottom(imageHeight - 1);
+                    }
+                } else if (m_optWidget->boolRatio->isChecked()) {
+                    if (! m_optWidget->boolWidth->isChecked() && !m_optWidget->boolHeight->isChecked()) {
+                        QRect newRect = m_rectCrop;
+                        switch (m_mouseOnHandleType) {
+                        case(UpperLeft): {
+                            qint32 dep = (drag.x() + drag.y()) / 2;
+                            newRect.setTop(newRect.top() + dep);
+                            newRect.setLeft(newRect.right() - m_optWidget->doubleRatio->value() * newRect.height());
                         }
-                        if (m_rectCrop.right() > imageWidth - 1) {
-                            m_rectCrop.moveRight(imageWidth - 1);
+                            break;
+                        case(LowerRight): {
+                            qint32 dep = (drag.x() + drag.y()) / 2;
+                            newRect.setBottom(newRect.bottom() + dep);
+                            newRect.setWidth((int)(m_optWidget->doubleRatio->value() * newRect.height()));
+                            break;
                         }
-                        if (m_rectCrop.top() < 0) {
-                            m_rectCrop.moveTop(0);
+                        case(UpperRight): {
+                            qint32 dep = (drag.x() - drag.y()) / 2;
+                            newRect.setTop(newRect.top() - dep);
+                            newRect.setWidth((int)(m_optWidget->doubleRatio->value() * newRect.height()));
+                            break;
                         }
-                        if (m_rectCrop.bottom() > imageHeight - 1) {
-                            m_rectCrop.moveBottom(imageHeight - 1);
+                        case(LowerLeft): {
+                            qint32 dep = (drag.x() - drag.y()) / 2;
+                            newRect.setBottom(newRect.bottom() - dep);
+                            newRect.setLeft((int)(newRect.right() - m_optWidget->doubleRatio->value() * newRect.height()));
+                            break;
                         }
-                    } else if (m_optWidget->boolRatio->isChecked()) {
-                        if (! m_optWidget->boolWidth->isChecked() && !m_optWidget->boolHeight->isChecked()) {
-                            QRect newRect = m_rectCrop;
-                            switch (m_mouseOnHandleType) {
-                            case(UpperLeft): {
-                                qint32 dep = (drag.x() + drag.y()) / 2;
-                                newRect.setTop(newRect.top() + dep);
-                                newRect.setLeft(newRect.right() - m_optWidget->doubleRatio->value() * newRect.height());
-                            }
+                        case(Upper):
+                            newRect.setTop(pos.y());
+                            newRect.setWidth((int)(newRect.height() * m_optWidget->doubleRatio->value()));
                             break;
-                            case(LowerRight): {
-                                qint32 dep = (drag.x() + drag.y()) / 2;
-                                newRect.setBottom(newRect.bottom() + dep);
-                                newRect.setWidth((int)(m_optWidget->doubleRatio->value() * newRect.height()));
-                                break;
-                            }
-                            case(UpperRight): {
-                                qint32 dep = (drag.x() - drag.y()) / 2;
-                                newRect.setTop(newRect.top() - dep);
-                                newRect.setWidth((int)(m_optWidget->doubleRatio->value() * newRect.height()));
-                                break;
-                            }
-                            case(LowerLeft): {
-                                qint32 dep = (drag.x() - drag.y()) / 2;
-                                newRect.setBottom(newRect.bottom() - dep);
-                                newRect.setLeft((int)(newRect.right() - m_optWidget->doubleRatio->value() * newRect.height()));
-                                break;
-                            }
-                            case(Upper):
-                                newRect.setTop(pos.y());
-                                newRect.setWidth((int)(newRect.height() * m_optWidget->doubleRatio->value()));
-                                break;
-                            case(Lower):
-                                newRect.setBottom(pos.y());
-                                newRect.setWidth((int)(newRect.height() * m_optWidget->doubleRatio->value()));
-                                break;
-                            case(Left):
-                                newRect.setLeft(pos.x());
-                                newRect.setHeight((int)(newRect.width() / m_optWidget->doubleRatio->value()));
-                                break;
-                            case(Right):
-                                newRect.setRight(pos.x());
-                                newRect.setHeight((int)(newRect.width() / m_optWidget->doubleRatio->value()));
-                                break;
-                            case(Inside):  // never happen
-                                break;
-                            }
-                            if (newRect.intersected(QRect(0,0,imageWidth,imageHeight))==newRect)
-                                m_rectCrop=newRect;
+                        case(Lower):
+                            newRect.setBottom(pos.y());
+                            newRect.setWidth((int)(newRect.height() * m_optWidget->doubleRatio->value()));
+                            break;
+                        case(Left):
+                            newRect.setLeft(pos.x());
+                            newRect.setHeight((int)(newRect.width() / m_optWidget->doubleRatio->value()));
+                            break;
+                        case(Right):
+                            newRect.setRight(pos.x());
+                            newRect.setHeight((int)(newRect.width() / m_optWidget->doubleRatio->value()));
+                            break;
+                        case(Inside):  // never happen
+                            break;
                         }
+                        if (newRect.intersected(QRect(0,0,imageWidth,imageHeight))==newRect)
+                            m_rectCrop=newRect;
+                    }
+                } else {
+                    if (m_optWidget->boolWidth->isChecked()) {
+                        m_rectCrop.setWidth(m_optWidget->intWidth->value());
                     } else {
-                        if (m_optWidget->boolWidth->isChecked()) {
-                            m_rectCrop.setWidth(m_optWidget->intWidth->value());
-                        } else {
-                            switch (m_mouseOnHandleType) {
-                            case(LowerLeft):
-                            case(Left):
-                            case(UpperLeft):
-                                m_rectCrop.setLeft(pos.x());
-                                break;
-                            case(Right):
-                            case(UpperRight):
-                            case(LowerRight):
-                                m_rectCrop.setRight(pos.x());
-                                break;
-                            default:
-                                break;
-                            }
+                        switch (m_mouseOnHandleType) {
+                        case(LowerLeft):
+                        case(Left):
+                        case(UpperLeft):
+                            m_rectCrop.setLeft(pos.x());
+                        break;
+                        case(Right):
+                        case(UpperRight):
+                        case(LowerRight):
+                            m_rectCrop.setRight(pos.x());
+                        break;
+                        default:
+                            break;
                         }
-                        if (m_optWidget->boolHeight->isChecked()) {
-                            m_rectCrop.setHeight(m_optWidget->intHeight->value());
-                        } else {
-                            switch (m_mouseOnHandleType) {
-                            case(UpperLeft):
-                            case(Upper):
-                            case(UpperRight):
-                                m_rectCrop.setTop(pos.y());
-                                break;
-                            case(LowerRight):
-                            case(LowerLeft):
-                            case(Lower):
-                                m_rectCrop.setBottom(pos.y());
-                                break;
-                            default:
-                                break;
-                            }
+                    }
+                    if (m_optWidget->boolHeight->isChecked()) {
+                        m_rectCrop.setHeight(m_optWidget->intHeight->value());
+                    } else {
+                        switch (m_mouseOnHandleType) {
+                        case(UpperLeft):
+                        case(Upper):
+                        case(UpperRight):
+                            m_rectCrop.setTop(pos.y());
+                        break;
+                        case(LowerRight):
+                        case(LowerLeft):
+                        case(Lower):
+                            m_rectCrop.setBottom(pos.y());
+                        break;
+                        default:
+                            break;
                         }
                     }
+                }
 
-                    m_rectCrop.setLeft(qBound(0, m_rectCrop.left(), image()->width() - 1));
-                    m_rectCrop.setRight(qBound(0, m_rectCrop.right(), image()->width() - 1));
-                    m_rectCrop.setTop(qBound(0, m_rectCrop.top(), image()->height() - 1));
-                    m_rectCrop.setBottom(qBound(0, m_rectCrop.bottom(), image()->height() - 1));
+                m_rectCrop.setLeft(qBound(0, m_rectCrop.left(), image()->width() - 1));
+                m_rectCrop.setRight(qBound(0, m_rectCrop.right(), image()->width() - 1));
+                m_rectCrop.setTop(qBound(0, m_rectCrop.top(), image()->height() - 1));
+                m_rectCrop.setBottom(qBound(0, m_rectCrop.bottom(), image()->height() - 1));
 
-                    m_dragStart = dragStop;
+                m_dragStart = dragStop;
 
-                    updateRect |= boundingRect();
-                    updateCanvasViewRect(updateRect);
-                }
+                updateRect |= boundingRect();
+                updateCanvasViewRect(updateRect);
             }
-            updateWidgetValues();
-        } else { //if we are not selecting
-            if (m_haveCropSelection) {  //if the crop selection is set
-                QPointF pos = convertToPixelCoord(e);
-                qint32 type = mouseOnHandle(pixelToView(pos));
-                //set resize cursor if we are on one of the handles
-                setMoveResizeCursor(type);
-            }
         }
+        updateWidgetValues();
     }
+    else {
+        KisTool::mouseMoveEvent(event);
+    }
 }
 
 void KisToolCrop::updateWidgetValues(bool updateratio)
@@ -317,11 +312,11 @@
         setOptionWidgetRatio((double)r.width() / (double)r.height());
 }
 
-void KisToolCrop::mouseReleaseEvent(KoPointerEvent *e)
+void KisToolCrop::mouseReleaseEvent(KoPointerEvent *event)
 {
-    if (canvas() && currentImage() && m_selecting && e->button() == Qt::LeftButton) {
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
 
-        m_selecting = false;
         m_haveCropSelection = true;
         m_rectCrop = m_rectCrop.normalized();
 
@@ -332,6 +327,9 @@
         updateRect |= boundingRect();
         updateCanvasViewRect(updateRect);
     }
+    else {
+        KisTool::mouseReleaseEvent(event);
+    }
 }
 
 void KisToolCrop::mouseDoubleClickEvent(KoPointerEvent *)
@@ -377,7 +375,7 @@
 
 void KisToolCrop::paintOutlineWithHandles(QPainter& gc)
 {
-    if (canvas() && (m_selecting || m_haveCropSelection)) {
+    if (canvas() && (mode() == KisTool::PAINT_MODE || m_haveCropSelection)) {
         gc.save();
 
 #if FADE_AREA_OUTSIDE_CROP
Index: plugins/tools/tool_crop/kis_tool_crop.h
===================================================================
--- plugins/tools/tool_crop/kis_tool_crop.h	(revision 1177751)
+++ plugins/tools/tool_crop/kis_tool_crop.h	(working copy)
@@ -116,7 +116,6 @@
 
 private:
     QRect m_rectCrop; // Is the coordinate of the region to crop.
-    bool m_selecting;
     QPoint m_dragStart;
 
     WdgToolCrop* m_optWidget;
Index: plugins/tools/tool_curves/kis_tool_curve.cc
===================================================================
--- plugins/tools/tool_curves/kis_tool_curve.cc	(revision 1177751)
+++ plugins/tools/tool_curves/kis_tool_curve.cc	(working copy)
@@ -65,7 +65,6 @@
 
     m_curve = 0;
 
-    m_dragging = false;
     m_draggingCursor = false;
     m_drawPivots = true;
     m_drawingPen = QPen(Qt::black, 0, Qt::SolidLine);
@@ -91,17 +90,18 @@
     }
 
     m_actionOptions = NOOPTIONS;
-    m_dragging = false;
     m_drawPivots = true;
 }
 
 void KisToolCurve::mousePressEvent(KoPointerEvent *event)
 {
     updateOptions(QApplication::keyboardModifiers());
-    if (!m_currentImage)
-        return;
-    if (event->button() == Qt::LeftButton) {
-        m_dragging = true;
+
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
+
+        setMode(KisTool::PAINT_MODE);
+
         m_currentPoint = event->pos().toPointF();
         PointPair temp = pointUnderMouse(m_subject->canvasController()->windowToView(event->pos()).toPointF());
         if (temp.first == m_curve->end() && !(m_actionOptions)) {
@@ -118,23 +118,66 @@
             else
                 m_current = selectByMouse(temp.first);
 
-            if (!(*m_current).isSelected())
-                m_dragging = false;
+            if (!(*m_current).isSelected()) {
+                setMode(KisTool::PAINT_HOVER);
+            }
+
             draw(true, true);
         }
     }
+    else {
+        KisToolPaint::mousePressEvent(event);
+    }
 }
 
+void KisToolCurve::mouseMoveEvent(KoPointerEvent *event)
+{
+    updateOptions(QApplication::keyboardModifiers());
+    PointPair temp = pointUnderMouse(m_subject->canvasController()->windowToView(event->pos()).toPointF());
+    if (temp.first == m_curve->end() && !mode() == KisTool::PAINT_MODE) {
+        if (m_draggingCursor) {
+            setCursor(KisCursor::load(m_cursor, 6, 6));
+            m_draggingCursor = false;
+        }
+    } else {
+        setCursor(KisCursor::load("tool_curve_dragging.png", 6, 6));
+/////////////////
+        m_draggingCursor = true;
+    }
+
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
+        QPointF trans = event->pos().toPointF() - m_currentPoint;
+        m_curve->moveSelected(trans);
+        m_currentPoint = event->pos().toPointF();
+        draw();
+    }
+    else {
+        KisToolPaint::mouseMoveEvent(event);
+    }
+}
+
+void KisToolCurve::mouseReleaseEvent(KoPointerEvent *event)
+{
+    updateOptions(QApplication::keyboardModifiers());
+
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
+    }
+    else {
+        KisToolPaint::mouseReleaseEvent(event);
+    }
+}
+
 void KisToolCurve::keyPressEvent(QKeyEvent *event)
 {
     if (event->key() == Qt::Key_Return) {
-        m_dragging = false;
+        setMode(KisTool::HOVER_MODE);
         commitCurve();
     } else if (event->key() == Qt::Key_Escape) {
-        m_dragging = false;
+        setMode(KisTool::HOVER_MODE);
         m_curve->clear();
     } else if (event->key() == Qt::Key_Delete) {
-        m_dragging = false;
+        setMode(KisTool::HOVER_MODE);
         m_curve->deleteSelected();
         m_current = m_curve->lastIterator();
         m_previous = m_curve->selectPivot(m_current);
@@ -147,38 +190,13 @@
 
 }
 
-void KisToolCurve::mouseReleaseEvent(KoPointerEvent *event)
-{
-    updateOptions(QApplication::keyboardModifiers());
-    m_dragging = false;
-}
-
 void KisToolCurve::mouseDoubleClick(KoPointerEvent *)
 {
     commitCurve();
 }
 
-void KisToolCurve::mouseMoveEvent(KoPointerEvent *event)
-{
-    updateOptions(QApplication::keyboardModifiers());
-    PointPair temp = pointUnderMouse(m_subject->canvasController()->windowToView(event->pos()).toPointF());
-    if (temp.first == m_curve->end() && !m_dragging) {
-        if (m_draggingCursor) {
-            setCursor(KisCursor::load(m_cursor, 6, 6));
-            m_draggingCursor = false;
-        }
-    } else {
-        setCursor(KisCursor::load("tool_curve_dragging.png", 6, 6));
-        m_draggingCursor = true;
-    }
-    if (m_dragging) {
-        QPointF trans = event->pos().toPointF() - m_currentPoint;
-        m_curve->moveSelected(trans);
-        m_currentPoint = event->pos().toPointF();
-        draw();
-    }
-}
 
+
 double pointToSegmentDistance(const QPointF& pp, const QPointF& pl0, const QPointF& pl1)
 {
     QPointF l0 = pl0, l1 = pl1, p = pp;
Index: plugins/tools/tool_curves/kis_tool_curve.h
===================================================================
--- plugins/tools/tool_curves/kis_tool_curve.h	(revision 1177751)
+++ plugins/tools/tool_curves/kis_tool_curve.h	(working copy)
@@ -151,7 +151,6 @@
     KisCurve::iterator m_previous;
     QPointF m_currentPoint;
 
-    bool m_dragging;
     bool m_drawPivots;
     QPen m_drawingPen;
     QPen m_pivotPen;
Index: plugins/tools/defaulttools/kis_tool_gradient.cc
===================================================================
--- plugins/tools/defaulttools/kis_tool_gradient.cc	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_gradient.cc	(working copy)
@@ -71,8 +71,7 @@
 #endif
 
 KisToolGradient::KisToolGradient(KoCanvasBase * canvas)
-        : KisToolPaint(canvas, KisCursor::load("tool_gradient_cursor.png", 6, 6)),
-        m_dragging(false)
+        : KisToolPaint(canvas, KisCursor::load("tool_gradient_cursor.png", 6, 6))
 {
     setObjectName("tool_gradient");
 
@@ -96,7 +95,7 @@
 
 void KisToolGradient::paint(QPainter &painter, const KoViewConverter &converter)
 {
-    if (m_dragging && m_startPos != m_endPos) {
+    if (mode() == KisTool::PAINT_MODE && m_startPos != m_endPos) {
 
 #if defined(HAVE_OPENGL) && defined(HAVE_GLEW)
         if (m_gradientProgram) {
@@ -172,18 +171,15 @@
     }
 }
 
-void KisToolGradient::mousePressEvent(KoPointerEvent *e)
+void KisToolGradient::mousePressEvent(KoPointerEvent *event)
 {
-    if (!currentImage()) {
-        return;
-    }
+    if(PRESS_CONDITION(event, KisTool::HOVER_MODE,
+                       Qt::LeftButton, Qt::NoModifier)) {
 
-    QPointF pos = convertToPixelCoord(e);
+        setMode(KisTool::PAINT_MODE);
 
-    if (e->button() == Qt::LeftButton) {
-        m_dragging = true;
-        m_startPos = pos;
-        m_endPos = pos;
+        m_startPos = convertToPixelCoord(event);
+        m_endPos = m_startPos;
 
 #if defined(HAVE_OPENGL) && defined(HAVE_GLEW)
         KisConfig cfg;
@@ -194,11 +190,8 @@
             KoColorProfile *monitorProfile = 0;
 
             Q_ASSERT(canvas);
+            monitorProfile = canvas->monitorProfile();
 
-            if (canvas) {
-                monitorProfile = canvas->monitorProfile();
-            }
-
             KisOpenGL::makeContextCurrent();
             m_gradientProgram = new KisOpenGLGradientProgram(currentGradient(),
                     m_shape,
@@ -210,19 +203,20 @@
         }
 #endif
     }
+    else {
+        KisToolPaint::mousePressEvent(event);
+    }
 }
 
-void KisToolGradient::mouseMoveEvent(KoPointerEvent *e)
+void KisToolGradient::mouseMoveEvent(KoPointerEvent *event)
 {
-    if (m_dragging) {
-        QPointF pos = convertToPixelCoord(e);
+    if(MOVE_CONDITION(event, KisTool::PAINT_MODE)) {
+        QPointF pos = convertToPixelCoord(event);
 
-        QRectF bound;
-        bound.setTopLeft(m_startPos);
-        bound.setBottomRight(m_endPos);
+        QRectF bound(m_startPos, m_endPos);
         canvas()->updateCanvas(convertToPt(bound.normalized()));
 
-        if ((e->modifiers() & Qt::ShiftModifier) == Qt::ShiftModifier) {
+        if (event->modifiers() == Qt::ShiftModifier) {
             m_endPos = straightLine(pos);
         } else {
             m_endPos = pos;
@@ -232,37 +226,38 @@
         bound.setBottomRight(m_endPos);
         canvas()->updateCanvas(convertToPt(bound.normalized()));
     }
+    else {
+        KisToolPaint::mouseMoveEvent(event);
+    }
 }
 
-void KisToolGradient::mouseReleaseEvent(KoPointerEvent *e)
+void KisToolGradient::mouseReleaseEvent(KoPointerEvent *event)
 {
-    if (!currentNode() || currentNode()->systemLocked())
-       return;
+    if(RELEASE_CONDITION(event, KisTool::PAINT_MODE, Qt::LeftButton)) {
+        setMode(KisTool::HOVER_MODE);
 
-    if (m_dragging && e->button() == Qt::LeftButton) {
+        if (!currentNode() || currentNode()->systemLocked())
+            return;
 
-        setCurrentNodeLocked(true);
-
 #if defined(HAVE_OPENGL) && defined(HAVE_GLEW)
         delete m_gradientProgram;
         m_gradientProgram = 0;
 #endif
 
-        m_dragging = false;
+        QPointF pos = convertToPixelCoord(event);
 
-        if (m_startPos == m_endPos) {
-            m_dragging = false;
-            return;
-        }
-
-        QPointF pos = convertToPixelCoord(e);
-
-        if ((e->modifiers() & Qt::ShiftModifier) == Qt::ShiftModifier) {
+        if (event->modifiers() == Qt::ShiftModifier) {
             m_endPos = straightLine(pos);
         } else {
             m_endPos = pos;
         }
 
+        if (m_startPos == m_endPos) {
+            return;
+        }
+
+        setCurrentNodeLocked(true);
+
         KisPaintDeviceSP device;
 
         if (currentImage() && (device = currentNode()->paintDevice())) {
@@ -300,6 +295,9 @@
         canvas()->updateCanvas(convertToPt(currentImage()->bounds()));
         setCurrentNodeLocked(false);
     }
+    else {
+        KisToolPaint::mouseReleaseEvent(event);
+    }
 }
 
 QPointF KisToolGradient::straightLine(QPointF point)
Index: plugins/tools/defaulttools/kis_tool_measure.h
===================================================================
--- plugins/tools/defaulttools/kis_tool_measure.h	(revision 1177751)
+++ plugins/tools/defaulttools/kis_tool_measure.h	(working copy)
@@ -93,7 +93,6 @@
     }
 
 private:
-    bool m_dragging;
     KisToolMeasureOptionsWidget *m_optWidget;
 
     QPointF m_startPos;
